Wapp - A Web-Application Framework for TCL
==========================================

Wapp is a framework for writing web applications in TCL,
with the following advantages:

  *   Small and simple API &rarr; easy to learn and use
  *   A complete app is a single small file of TCL
  *   Resistant to attacks and exploits
  *   Cross-platform &rarr; CGI, SCGI, or a built-in web server
  *   The Wapp framework itself is a single-file TCL script
  *   Easy to embed in a larger application, if desired
  *   2-clause BSD license

Documentation
-------------

  *  ["Hello World!" App (6 lines of code)](/doc/trunk/docs/helloworld.md)
  *  [Introduction To Writing Wapp Applications](/doc/trunk/docs/intro.md)
  *  [Quick Reference](/doc/trunk/docs/quickref.md)
  *  [Wapp Parameters](/doc/trunk/docs/params.md)
  *  [Wapp Commands](/doc/trunk/docs/commands.md)
  *  [CGI Parameters](/doc/trunk/docs/quickref.md#cgiparams)
  *  [URL Mapping](/doc/trunk/docs/urlmapping.md)
  *  [Security Features](/doc/trunk/docs/security.md)
  *  [How To Compile wapptclsh - Or Not](/doc/trunk/docs/compiling.md)
  *  [Limitations of Wapp](/doc/trunk/docs/limitations.md)
  *  [Example Applications](/file/examples)
  *  [Real-World Uses Of Wapp](/doc/trunk/docs/usageexamples.md)
  *  [Debugging Hints](/doc/trunk/docs/debughints.md)

Simple Live Demos
-----------------

  *  <https://wapp.tcl.tk/demo/>

Downloads
---------

  *   Download just the single
      [Wapp TCL file](/file/wapp.tcl?mimetype=text/plain), if you already
      have a TCL environment
  *   Download a [tarball](/tarball/wapp.tar.gz) or
      [ZIP Archive](/zip/wapp.zip) of the latest snapshot of this
      entire repository, or
  *   Clone the entire repository using the [Fossil](https://fossil-scm.org/)
      command "fossil clone [](https://wapp.tcl.tk)".

Extended And Enhanced Wapp By Oleg (lego12239)
----------------------------------------------

  *  <https://github.com/lego12239/wapp>
